"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = exports.is = exports.assert = exports.apply = void 0;
const Trace_1 = require("./Trace");
function apply(hyperval, raw) {
    if (arguments.length === 2) {
        return hyperval.hyper(raw, new Trace_1.Trace(raw));
    }
    else {
        return (raw) => apply(hyperval, raw);
    }
}
exports.apply = apply;
function assert(hyperval, raw) {
    if (arguments.length === 2) {
        apply(hyperval, raw);
    }
    else {
        return (raw) => assert(hyperval, raw);
    }
}
exports.assert = assert;
function is(hyperval, raw) {
    if (arguments.length === 2) {
        try {
            apply(hyperval, raw);
            return true;
        }
        catch (e) {
            if (e instanceof Trace_1.HypervalError) {
                return false;
            }
            else {
                throw e;
            }
        }
    }
    else {
        return (raw) => is(hyperval, raw);
    }
}
exports.is = is;
function validate(hyperval, raw) {
    if (arguments.length === 2) {
        try {
            return { result: apply(hyperval, raw) };
        }
        catch (error) {
            if (error instanceof Trace_1.HypervalError) {
                return { error };
            }
            else {
                throw error;
            }
        }
    }
    else {
        return (raw) => validate(hyperval, raw);
    }
}
exports.validate = validate;
