import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
declare type UnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends ((k: infer I) => void) ? I : never;
export declare class HyperAND<T extends Array<Hyper<any, any>>> extends Hyper<UnionToIntersection<T extends Array<infer U> ? HyperRaw<U> : never>, UnionToIntersection<T extends Array<infer U> ? HyperVal<U> : never>> {
    /** OR schema */
    readonly schema: T;
    constructor(
    /** OR schema */
    schema: T, ...hyper: HyperConstructor<UnionToIntersection<T extends Array<infer U> ? HyperVal<U> : never>>);
}
/**
 * Validates a value to match all of the provided values.
 *
 * @param hyperval Tests of which all must succeed.
 */
export declare function and<T extends Hyper<any>, U extends Hyper<any>, V extends Hyper<any>[]>(...hyperval: [T, U, ...V]): HyperAND<[T, U, ...V]>;
export {};
