"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.and = exports.HyperAND = void 0;
const Hyper_1 = require("../Hyper");
const Trace_1 = require("../Trace");
class HyperAND extends Hyper_1.Hyper {
    constructor(
    /** OR schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperAND = HyperAND;
/**
 * Validates a value to match all of the provided values.
 *
 * @param hyperval Tests of which all must succeed.
 */
function and(...hyperval) {
    return new HyperAND(hyperval, 'and', function (raw, failure) {
        let collective = raw;
        let path = -1;
        try {
            for (let i = 0; i < hyperval.length; i++) {
                const t = hyperval[i];
                if (!t)
                    continue;
                path = i;
                collective = t.hyper(collective, failure.fork(i));
            }
            return collective;
        }
        catch (e) {
            if (!(e instanceof Trace_1.HypervalError))
                throw e;
            failure.throw(`and: Validation failed at: ${path}`);
            throw e;
        }
    });
}
exports.and = and;
