import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperOR<T extends Array<Hyper<any, any>>> extends Hyper<T extends Array<infer U> ? HyperRaw<U> : never, T extends Array<infer U> ? HyperVal<U> : never> {
    /** OR schema */
    readonly schema: T;
    constructor(
    /** OR schema */
    schema: T, ...hyper: HyperConstructor<T extends Array<infer U> ? HyperVal<U> : never>);
}
/**
 * Validates a value to match at least one of the provided values.
 *
 * @param hyperval Tests of which at least one must succeed.
 */
export declare function or<T extends Hyper<any>, U extends Hyper<any>, V extends Array<Hyper<any>>>(...hyperval: [T, U, ...V]): HyperOR<[T, U, ...V]>;
