"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.or = exports.HyperOR = void 0;
const Hyper_1 = require("../Hyper");
const Trace_1 = require("../Trace");
class HyperOR extends Hyper_1.Hyper {
    constructor(
    /** OR schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperOR = HyperOR;
/**
 * Validates a value to match at least one of the provided values.
 *
 * @param hyperval Tests of which at least one must succeed.
 */
function or(...hyperval) {
    return new HyperOR(hyperval, 'or', function (raw, failure) {
        for (const t of hyperval) {
            try {
                return t.hyper(raw, failure);
            }
            catch (e) {
                if (!(e instanceof Trace_1.HypervalError))
                    throw e;
            }
        }
        failure.throw(`or: ${hyperval.map(x => x.onfail).join(`; `)}`);
    });
}
exports.or = or;
