import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperXOR<T extends Array<Hyper<any, any>>> extends Hyper<T extends Array<infer U> ? HyperRaw<U> : never, T extends Array<infer U> ? HyperVal<U> : never> {
    /** XOR schema */
    readonly schema: T;
    constructor(
    /** XOR schema */
    schema: T, ...hyper: HyperConstructor<T extends Array<infer U> ? HyperVal<U> : never>);
}
/**
 * Validates a value to match one, and only one of the provided values.
 *
 * @param hyperval Tests of which at only one must succeed.
 */
export declare function xor<T extends Hyper<any, any>, U extends Hyper<any, any>, V extends Array<Hyper<any, any>>>(...hyperval: [T, U, ...V]): HyperXOR<[T, U, ...V]>;
