"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.xor = exports.HyperXOR = void 0;
const Hyper_1 = require("../Hyper");
const Trace_1 = require("../Trace");
class HyperXOR extends Hyper_1.Hyper {
    constructor(
    /** XOR schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperXOR = HyperXOR;
/**
 * Validates a value to match one, and only one of the provided values.
 *
 * @param hyperval Tests of which at only one must succeed.
 */
function xor(...hyperval) {
    return new HyperXOR(hyperval, 'xor', function (raw, failure) {
        let success = undefined;
        for (const t of hyperval) {
            if (success) {
                let s = false;
                try {
                    t.hyper(raw, failure);
                    s = true;
                }
                catch (_a) { }
                if (s)
                    failure.throw('xor multiple success');
            }
            else {
                try {
                    success = { data: t.hyper(raw, failure) };
                }
                catch (e) {
                    if (!(e instanceof Trace_1.HypervalError))
                        throw e;
                }
            }
        }
        if (!success) {
            failure.throw(`xor: ${hyperval.map(x => x.onfail).join(`; `)}`);
        }
        else {
            return success.data;
        }
    });
}
exports.xor = xor;
