import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperArray<T extends Hyper<any, any>> extends Hyper<Array<HyperRaw<T>>, Array<HyperVal<T>>> {
    /**
     * Array schema.
     */
    readonly schema: T;
    constructor(
    /**
     * Array schema.
     */
    schema: T, ...hyper: HyperConstructor<HyperVal<T>>);
}
/**
 * Validates value to be an array of unknown values.
 */
export declare function array(): HyperArray<Hyper<unknown>>;
/**
 * Validates value to be an array of provided type.
 * Use {@link tuple} if you need to validate at each array position.
 *
 * @param hyper Array values.
 */
export declare function array<T extends Hyper<any, any>>(hyper: T): HyperArray<T>;
