"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.array = exports.HyperArray = void 0;
const Hyper_1 = require("../Hyper");
const any_1 = require("../primitive/any");
class HyperArray extends Hyper_1.Hyper {
    constructor(
    /**
     * Array schema.
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperArray = HyperArray;
function array(hyper) {
    return new HyperArray(hyper !== null && hyper !== void 0 ? hyper : any_1.any(), 'array', function (x, failure) {
        if (!Array.isArray(x))
            failure.throw('Is not array');
        if (!hyper)
            return x;
        let i = x.length;
        const result = new Array(i);
        while (--i >= 0) {
            result[i] = hyper.hyper(x[i], failure.fork(i));
        }
        return result;
    });
}
exports.array = array;
