import type { HyperConstructor, HyperVal, HyperRaw } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperMap<T extends Hyper<any, any>, U extends Hyper<any, any>> extends Hyper<Map<HyperRaw<T>, HyperRaw<U>>, Map<HyperVal<T>, HyperVal<U>>> {
    /**
     * Map Schema
     */
    readonly schema: {
        /** Key */
        key: T;
        /** Value */
        val: U;
    };
    constructor(
    /**
     * Map Schema
     */
    schema: {
        /** Key */
        key: T;
        /** Value */
        val: U;
    }, ...hyper: HyperConstructor<Map<HyperVal<T>, HyperVal<U>>>);
}
/**
 * Validates a value to be a map of `Map<key, value>`
 *
 * @param keyhyper Key value.
 * @param valhyper Data value.
 */
export declare function map<T extends Hyper<any, any>, U extends Hyper<any, any>>(keyhyper: T, valhyper: U): HyperMap<T, U>;
