"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.map = exports.HyperMap = void 0;
const Hyper_1 = require("../Hyper");
const instance_1 = require("../primitive/instance");
class HyperMap extends Hyper_1.Hyper {
    constructor(
    /**
     * Map Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperMap = HyperMap;
/**
 * Validates a value to be a map of `Map<key, value>`
 *
 * @param keyhyper Key value.
 * @param valhyper Data value.
 */
function map(keyhyper, valhyper) {
    const is_map = instance_1.instance(Map);
    return new HyperMap({ key: keyhyper, val: valhyper }, 'map', function (raw, failure) {
        const m = is_map.hyper(raw, failure);
        const next = new Map();
        for (const [k, v] of m) {
            next.set(keyhyper.hyper(k, failure.fork(k)), valhyper.hyper(v, failure.fork(k)));
        }
        return next;
    });
}
exports.map = map;
