import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
import { HyperOptional } from '../modifier/optional';
import type { Trace } from '../Trace';
declare type NoOptional<T extends {
    [i: string]: Hyper<any> | HyperOptional<any>;
}> = {
    [K in keyof T]: T[K] extends HyperOptional<any> ? never : K;
}[keyof T];
declare type OnlyOptional<T extends {
    [i: string]: Hyper<any> | HyperOptional<any>;
}> = {
    [K in keyof T]: T[K] extends HyperOptional<any> ? K : never;
}[keyof T];
declare type MaskHyperOptional<T extends {
    [i: string]: Hyper<any>;
}> = {
    [K in NoOptional<T>]-?: T[K];
} & {
    [K in OnlyOptional<T>]+?: T[K];
};
export declare function is_object<T extends {
    [i: string]: unknown;
}>(raw: any, failure: Trace): asserts raw is T;
export declare class HyperObject<T extends {
    [K: string]: Hyper<any>;
}> extends Hyper<MaskHyperOptional<T> extends infer U ? {
    [K in keyof U]: HyperRaw<U[K]>;
} : never, MaskHyperOptional<T> extends infer U ? {
    [K in keyof U]: HyperVal<U[K]>;
} : never> {
    /**
     * Object schema
     */
    readonly schema: T;
    constructor(
    /**
     * Object schema
     */
    schema: T, ...hyper: HyperConstructor<MaskHyperOptional<T> extends infer U ? {
        [K in keyof U]: HyperVal<U[K]>;
    } : never>);
}
export declare function object_core<T extends {
    [K: string]: Hyper<any>;
}>(check_length: boolean, value: T): HyperObject<T>;
export {};
