"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.record = exports.HyperLooseRecord = exports.HyperRecord = void 0;
const Hyper_1 = require("../Hyper");
const object_core_1 = require("./object-core");
class HyperRecord extends Hyper_1.Hyper {
    constructor(
    /**
     * Record Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperRecord = HyperRecord;
class HyperLooseRecord extends Hyper_1.Hyper {
    constructor(
    /**
     * Record Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperLooseRecord = HyperLooseRecord;
function record(keyhyper, valhyper, loose) {
    return new (loose === 'strict' ? HyperRecord : HyperLooseRecord)({ key: keyhyper, val: valhyper }, 'record', function (raw, failure) {
        object_core_1.is_object(raw, failure);
        const result = {};
        for (const [k, v] of Object.entries(raw)) {
            result[keyhyper.hyper(k, failure.fork(k))] = valhyper.hyper(v, failure.fork(k));
        }
        return result;
    });
}
exports.record = record;
