import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperSet<T extends Hyper<any, any>> extends Hyper<Set<HyperRaw<T>>, Set<HyperVal<T>>> {
    /**
     * Set schema.
     */
    readonly schema: T;
    constructor(
    /**
     * Set schema.
     */
    schema: T, ...hyper: HyperConstructor<HyperVal<T>>);
}
/**
 * Validates value to be an set of unknown values.
 */
export declare function set(): HyperSet<Hyper<unknown>>;
/**
 * Validates value to be an set of provided type.
 *
 * @param hyper Set values.
 */
export declare function set<T extends Hyper<any>>(hyper: T): HyperSet<T>;
