"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.set = exports.HyperSet = void 0;
const Hyper_1 = require("../Hyper");
const any_1 = require("../primitive/any");
class HyperSet extends Hyper_1.Hyper {
    constructor(
    /**
     * Set schema.
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperSet = HyperSet;
function set(hyper) {
    return new HyperSet(hyper !== null && hyper !== void 0 ? hyper : any_1.any(), 'set', function (x, failure) {
        if (!(x instanceof Set))
            failure.throw('Is not set');
        if (!hyper)
            return x;
        const result = new Set();
        for (const s of x) {
            result.add(hyper.hyper(s, failure.fork(s)));
        }
        return result;
    });
}
exports.set = set;
