import type { HyperConstructor, HyperRaw, HyperVal } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperTuple<T extends Array<string | boolean | number | null | undefined | bigint | Hyper<any>>> extends Hyper<{
    [K in keyof T]: HyperRaw<T[K]>;
}, {
    [K in keyof T]: HyperVal<T[K]>;
}> {
    /**
     * Tuple schema.
     */
    readonly schema: T;
    constructor(
    /**
     * Tuple schema.
     */
    schema: T, ...hyper: HyperConstructor<{
        [K in keyof T]: HyperVal<T[K]>;
    }>);
}
/**
 * Validates value to be a tuple.
 *
 * @param hyper Tuple value.
 */
export declare function tuple<T extends Array<string | boolean | number | null | undefined | bigint | Hyper<any>>>(hyper: readonly [...T]): HyperTuple<[...T]>;
