"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.augment = exports.HyperAugment = void 0;
const Hyper_1 = require("../Hyper");
class HyperAugment extends Hyper_1.Hyper {
    constructor(
    /** Unaugment schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperAugment = HyperAugment;
function augment(hyperaugment, augmentation) {
    if (hyperaugment instanceof Hyper_1.Hyper && augmentation) {
        return new HyperAugment(hyperaugment, 'augment', function (raw, failure) {
            const result = hyperaugment.hyper(raw, failure);
            if (!augmentation(result))
                failure.throw('Type augmentation failed');
            return result;
        });
    }
    else {
        return (hyperval) => augment(hyperval, hyperaugment);
    }
}
exports.augment = augment;
