import type { HyperConstructor, HyperVal, HyperRaw } from '../Hyper';
import { Hyper } from '../Hyper';
export declare class HyperNull<T extends Hyper<any, any>> extends Hyper<HyperRaw<T> | null, HyperVal<T> | null> {
    /** Unnullable schema */
    readonly schema: T;
    constructor(
    /** Unnullable schema */
    schema: T, ...hyper: HyperConstructor<HyperVal<T>>);
}
/**
 * Makes a test accept null.
 * Use {@link literal} if you want a literal null.
 *
 * @param hyper Test to accept nulls.
 */
export declare function nullable<T extends Hyper<any>>(hyper: T): HyperNull<T>;
