"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nullable = exports.HyperNull = void 0;
const Hyper_1 = require("../Hyper");
class HyperNull extends Hyper_1.Hyper {
    constructor(
    /** Unnullable schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
exports.HyperNull = HyperNull;
/**
 * Makes a test accept null.
 * Use {@link literal} if you want a literal null.
 *
 * @param hyper Test to accept nulls.
 */
function nullable(hyper) {
    return new HyperNull(hyper, 'nullable', function (raw, failure) {
        if (raw === null)
            return raw;
        return hyper.hyper(raw, failure);
    });
}
exports.nullable = nullable;
