"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.optional = exports.HyperOptional = exports.OPTIONAL_MARKER = void 0;
const Hyper_1 = require("../Hyper");
exports.OPTIONAL_MARKER = Symbol();
class HyperOptional extends Hyper_1.Hyper {
    constructor(
    /** Unoptional schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
        this._ = exports.OPTIONAL_MARKER;
    }
}
exports.HyperOptional = HyperOptional;
/**
 * Makes a test accept undefined.
 * Use {@link literal} if you want a literal undefined.
 *
 * @param hyper Hyper to accept undefined.
 */
function optional(hyper) {
    return new HyperOptional(hyper, 'optional', function (raw, failure) {
        if (raw === undefined)
            return raw;
        return hyper.hyper(raw, failure);
    });
}
exports.optional = optional;
