import type { Hyper } from '../Hyper';
/**
 * Validates value to be a string.
 */
export declare function string(): Hyper<string>;
/**
 * Validates value to be a string.
 * String must also pass regular expression.
 *
 * @param regexp A regular expression that must evaluate to true in order for string to be valid.
 */
export declare function string(regexp: RegExp): Hyper<string>;
/**
 * Validates value to be a string.
 * String must also not pass regular expression.
 *
 * @param regexp A regular expression that must evaluate to false in order for string to be valid.
 * @param negate Set to 'negate' to enable this overload.
 */
export declare function string(regexp: RegExp, negate: 'negate'): Hyper<string>;
/**
 * Validates value to be a string.
 * String must also pass augmentation function.
 *
 * @param augment Adds an augmentation function that must evaluate to `true` in order for string to be valid.
 */
export declare function string(augment: (x: string) => boolean): Hyper<string>;
