"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.string = void 0;
const Hyper_1 = require("../Hyper");
const augment_1 = require("../modifier/augment");
const hyper = Hyper_1.hyperval_factory('string', x => typeof x === 'string');
function string(modifier, negate) {
    if (modifier) {
        if (typeof modifier === 'function') {
            return augment_1.augment(hyper, modifier);
        }
        else {
            if (negate === 'negate') {
                return augment_1.augment(hyper, x => !modifier.test(x));
            }
            else {
                return augment_1.augment(hyper, x => modifier.test(x));
            }
        }
    }
    else {
        return hyper;
    }
}
exports.string = string;
