import { HypervalError, Trace } from './Trace';
export function apply(hyperval, raw) {
    if (arguments.length === 2) {
        return hyperval.hyper(raw, new Trace(raw));
    }
    else {
        return (raw) => apply(hyperval, raw);
    }
}
export function assert(hyperval, raw) {
    if (arguments.length === 2) {
        apply(hyperval, raw);
    }
    else {
        return (raw) => assert(hyperval, raw);
    }
}
export function is(hyperval, raw) {
    if (arguments.length === 2) {
        try {
            apply(hyperval, raw);
            return true;
        }
        catch (e) {
            if (e instanceof HypervalError) {
                return false;
            }
            else {
                throw e;
            }
        }
    }
    else {
        return (raw) => is(hyperval, raw);
    }
}
export function validate(hyperval, raw) {
    if (arguments.length === 2) {
        try {
            return { result: apply(hyperval, raw) };
        }
        catch (error) {
            if (error instanceof HypervalError) {
                return { error };
            }
            else {
                throw error;
            }
        }
    }
    else {
        return (raw) => validate(hyperval, raw);
    }
}
