import { Hyper } from '../Hyper';
import { HypervalError } from '../Trace';
export class HyperAND extends Hyper {
    constructor(
    /** OR schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
/**
 * Validates a value to match all of the provided values.
 *
 * @param hyperval Tests of which all must succeed.
 */
export function and(...hyperval) {
    return new HyperAND(hyperval, 'and', function (raw, failure) {
        let collective = raw;
        let path = -1;
        try {
            for (let i = 0; i < hyperval.length; i++) {
                const t = hyperval[i];
                if (!t)
                    continue;
                path = i;
                collective = t.hyper(collective, failure.fork(i));
            }
            return collective;
        }
        catch (e) {
            if (!(e instanceof HypervalError))
                throw e;
            failure.throw(`and: Validation failed at: ${path}`);
            throw e;
        }
    });
}
