import { Hyper } from '../Hyper';
import { HypervalError } from '../Trace';
export class HyperOR extends Hyper {
    constructor(
    /** OR schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
/**
 * Validates a value to match at least one of the provided values.
 *
 * @param hyperval Tests of which at least one must succeed.
 */
export function or(...hyperval) {
    return new HyperOR(hyperval, 'or', function (raw, failure) {
        for (const t of hyperval) {
            try {
                return t.hyper(raw, failure);
            }
            catch (e) {
                if (!(e instanceof HypervalError))
                    throw e;
            }
        }
        failure.throw(`or: ${hyperval.map(x => x.onfail).join(`; `)}`);
    });
}
