import { Hyper } from '../Hyper';
import { any } from '../primitive/any';
export class HyperArray extends Hyper {
    constructor(
    /**
     * Array schema.
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
export function array(hyper) {
    return new HyperArray(hyper !== null && hyper !== void 0 ? hyper : any(), 'array', function (x, failure) {
        if (!Array.isArray(x))
            failure.throw('Is not array');
        if (!hyper)
            return x;
        let i = x.length;
        const result = new Array(i);
        while (--i >= 0) {
            result[i] = hyper.hyper(x[i], failure.fork(i));
        }
        return result;
    });
}
