import { Hyper } from '../Hyper';
import { instance } from '../primitive/instance';
export class HyperMap extends Hyper {
    constructor(
    /**
     * Map Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
/**
 * Validates a value to be a map of `Map<key, value>`
 *
 * @param keyhyper Key value.
 * @param valhyper Data value.
 */
export function map(keyhyper, valhyper) {
    const is_map = instance(Map);
    return new HyperMap({ key: keyhyper, val: valhyper }, 'map', function (raw, failure) {
        const m = is_map.hyper(raw, failure);
        const next = new Map();
        for (const [k, v] of m) {
            next.set(keyhyper.hyper(k, failure.fork(k)), valhyper.hyper(v, failure.fork(k)));
        }
        return next;
    });
}
