import { Hyper } from '../Hyper';
import { is_object } from './object-core';
export class HyperRecord extends Hyper {
    constructor(
    /**
     * Record Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
export class HyperLooseRecord extends Hyper {
    constructor(
    /**
     * Record Schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
export function record(keyhyper, valhyper, loose) {
    return new (loose === 'strict' ? HyperRecord : HyperLooseRecord)({ key: keyhyper, val: valhyper }, 'record', function (raw, failure) {
        is_object(raw, failure);
        const result = {};
        for (const [k, v] of Object.entries(raw)) {
            result[keyhyper.hyper(k, failure.fork(k))] = valhyper.hyper(v, failure.fork(k));
        }
        return result;
    });
}
