import { Hyper } from '../Hyper';
import { any } from '../primitive/any';
export class HyperSet extends Hyper {
    constructor(
    /**
     * Set schema.
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
export function set(hyper) {
    return new HyperSet(hyper !== null && hyper !== void 0 ? hyper : any(), 'set', function (x, failure) {
        if (!(x instanceof Set))
            failure.throw('Is not set');
        if (!hyper)
            return x;
        const result = new Set();
        for (const s of x) {
            result.add(hyper.hyper(s, failure.fork(s)));
        }
        return result;
    });
}
