import { Hyper } from '../Hyper';
export class HyperAugment extends Hyper {
    constructor(
    /** Unaugment schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
export function augment(hyperaugment, augmentation) {
    if (hyperaugment instanceof Hyper && augmentation) {
        return new HyperAugment(hyperaugment, 'augment', function (raw, failure) {
            const result = hyperaugment.hyper(raw, failure);
            if (!augmentation(result))
                failure.throw('Type augmentation failed');
            return result;
        });
    }
    else {
        return (hyperval) => augment(hyperval, hyperaugment);
    }
}
