import { Hyper } from '../Hyper';
export class HyperNull extends Hyper {
    constructor(
    /** Unnullable schema */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
/**
 * Makes a test accept null.
 * Use {@link literal} if you want a literal null.
 *
 * @param hyper Test to accept nulls.
 */
export function nullable(hyper) {
    return new HyperNull(hyper, 'nullable', function (raw, failure) {
        if (raw === null)
            return raw;
        return hyper.hyper(raw, failure);
    });
}
