import { hyperval_factory } from '../Hyper';
import { augment } from '../modifier/augment';
const hyper = hyperval_factory('string', x => typeof x === 'string');
export function string(modifier, negate) {
    if (modifier) {
        if (typeof modifier === 'function') {
            return augment(hyper, modifier);
        }
        else {
            if (negate === 'negate') {
                return augment(hyper, x => !modifier.test(x));
            }
            else {
                return augment(hyper, x => modifier.test(x));
            }
        }
    }
    else {
        return hyper;
    }
}
